searchData={"items":[{"type":"module","title":"GettextTranslator.Dashboard.Components.GettextDashboardCSS","doc":"Provides CSS styles for the Gettext Translator Dashboard that match\nPhoenix LiveDashboard's look and feel.","ref":"GettextTranslator.Dashboard.Components.GettextDashboardCSS.html"},{"type":"function","title":"GettextTranslator.Dashboard.Components.GettextDashboardCSS.styles/0","doc":"","ref":"GettextTranslator.Dashboard.Components.GettextDashboardCSS.html#styles/0"},{"type":"module","title":"GettextTranslator.Dashboard.Components.Header","doc":"Header component for the Gettext Translator dashboard.","ref":"GettextTranslator.Dashboard.Components.Header.html"},{"type":"function","title":"GettextTranslator.Dashboard.Components.Header.render/1","doc":"","ref":"GettextTranslator.Dashboard.Components.Header.html#render/1"},{"type":"function","title":"Attributes - GettextTranslator.Dashboard.Components.Header.render/1","doc":"* `gettext_path` (`:string`) (required)\n* `translations_count` (`:integer`) (required)\n* `translations_loaded` (`:boolean`) (required)\n* `modified_count` (`:integer`) - Defaults to `0`.\n* `approved_count` (`:integer`) - Defaults to `0`.\n* `loading` (`:boolean`) - Defaults to `false`.","ref":"GettextTranslator.Dashboard.Components.Header.html#render/1-attributes"},{"type":"module","title":"GettextTranslator.Dashboard.Components.TranslationDetails","doc":"Component for showing and editing translation details.","ref":"GettextTranslator.Dashboard.Components.TranslationDetails.html"},{"type":"function","title":"GettextTranslator.Dashboard.Components.TranslationDetails.changelog_badge/1","doc":"","ref":"GettextTranslator.Dashboard.Components.TranslationDetails.html#changelog_badge/1"},{"type":"function","title":"Attributes - GettextTranslator.Dashboard.Components.TranslationDetails.changelog_badge/1","doc":"* `status` (`:string`) (required)","ref":"GettextTranslator.Dashboard.Components.TranslationDetails.html#changelog_badge/1-attributes"},{"type":"function","title":"GettextTranslator.Dashboard.Components.TranslationDetails.render/1","doc":"","ref":"GettextTranslator.Dashboard.Components.TranslationDetails.html#render/1"},{"type":"function","title":"Attributes - GettextTranslator.Dashboard.Components.TranslationDetails.render/1","doc":"* `viewing_language` (`:string`) (required)\n* `viewing_domain` (`:string`) (required)\n* `filtered_translations` (`:list`) (required)\n* `editing_id` (`:string`) - Defaults to `nil`.","ref":"GettextTranslator.Dashboard.Components.TranslationDetails.html#render/1-attributes"},{"type":"function","title":"GettextTranslator.Dashboard.Components.TranslationDetails.status_badge/1","doc":"","ref":"GettextTranslator.Dashboard.Components.TranslationDetails.html#status_badge/1"},{"type":"function","title":"Attributes - GettextTranslator.Dashboard.Components.TranslationDetails.status_badge/1","doc":"* `status` (`:atom`) (required)","ref":"GettextTranslator.Dashboard.Components.TranslationDetails.html#status_badge/1-attributes"},{"type":"function","title":"GettextTranslator.Dashboard.Components.TranslationDetails.translation_edit_form/1","doc":"","ref":"GettextTranslator.Dashboard.Components.TranslationDetails.html#translation_edit_form/1"},{"type":"function","title":"Attributes - GettextTranslator.Dashboard.Components.TranslationDetails.translation_edit_form/1","doc":"* `translation` (`:map`) (required)","ref":"GettextTranslator.Dashboard.Components.TranslationDetails.html#translation_edit_form/1-attributes"},{"type":"module","title":"GettextTranslator.Dashboard.Components.TranslationStats","doc":"Component for displaying translation statistics.","ref":"GettextTranslator.Dashboard.Components.TranslationStats.html"},{"type":"function","title":"GettextTranslator.Dashboard.Components.TranslationStats.render/1","doc":"","ref":"GettextTranslator.Dashboard.Components.TranslationStats.html#render/1"},{"type":"function","title":"Attributes - GettextTranslator.Dashboard.Components.TranslationStats.render/1","doc":"* `translations` (`:list`) (required)","ref":"GettextTranslator.Dashboard.Components.TranslationStats.html#render/1-attributes"},{"type":"module","title":"GettextTranslator","doc":"A module for translating gettext files.\n\nThis module provides functionality to scan directories for gettext files,\nprocess translation folders, and summarize the results. It leverages helper functions\nand processors defined in other modules.","ref":"GettextTranslator.html"},{"type":"module","title":"Overview - GettextTranslator","doc":"The main entry point of this module is the `translate/2` function which:\n  1. Scans the specified root directory for gettext files using `Parser.scan/1`.\n  2. Processes each folder corresponding to a language.\n  3. Summarizes the total number of translations made.\n\nLanguages that are defined in the `provider`'s `ignored_languages` list will be skipped,\nand a log message is generated.","ref":"GettextTranslator.html#module-overview"},{"type":"module","title":"Example Usage - GettextTranslator","doc":"iex> provider = %{ignored_languages: [\"fr\", \"de\"]}\n    iex> root_path = \"path/to/gettext\"\n    iex> GettextTranslator.configure(application: :my_app)\n    iex> GettextTranslator.translate(provider, root_path)\n    {:ok, total_translations}","ref":"GettextTranslator.html#module-example-usage"},{"type":"function","title":"GettextTranslator.application/0","doc":"Returns the configured application name or nil if not configured.","ref":"GettextTranslator.html#application/0"},{"type":"function","title":"GettextTranslator.configure/1","doc":"Configures the GettextTranslator module.","ref":"GettextTranslator.html#configure/1"},{"type":"function","title":"Options - GettextTranslator.configure/1","doc":"* `:application` - The OTP application name to use for resolving paths","ref":"GettextTranslator.html#configure/1-options"},{"type":"function","title":"Example - GettextTranslator.configure/1","doc":"iex> GettextTranslator.configure(application: :my_app)\n    :ok","ref":"GettextTranslator.html#configure/1-example"},{"type":"function","title":"GettextTranslator.translate/2","doc":"Translates the gettext files located at the given root path.\n\nThis function performs the following steps:\n  1. Scans the `root_gettext_path` for gettext files using `Parser.scan/1`.\n  2. Processes each language folder found by filtering out languages that are ignored\n     (as specified in the `provider` map's `ignored_languages` key) and running the translation\n     process on the rest using `Processor.run/2`.\n  3. Summarizes the total number of translations performed across all folders.","ref":"GettextTranslator.html#translate/2"},{"type":"function","title":"Parameters - GettextTranslator.translate/2","doc":"- `provider`: A map or struct that configures the translation process. It must include an\n    `ignored_languages` key which is a list of language codes to be skipped.\n  - `root_gettext_path`: The root directory path where gettext files are stored.\n                        Can be a relative path \"priv/gettext\" or an absolute path.","ref":"GettextTranslator.html#translate/2-parameters"},{"type":"function","title":"Return Value - GettextTranslator.translate/2","doc":"Returns `{:ok, total}` where `total` is the sum of translations performed.\nIf the scan fails, the function will return the corresponding error tuple.","ref":"GettextTranslator.html#translate/2-return-value"},{"type":"function","title":"Examples - GettextTranslator.translate/2","doc":"iex> provider = %{ignored_languages: [\"fr\", \"de\"]}\n    iex> root_gettext_path = \"priv/gettext\"\n    iex> GettextTranslator.translate(provider, root_gettext_path)\n    {:ok, total_translations}","ref":"GettextTranslator.html#translate/2-examples"},{"type":"module","title":"GettextTranslator.Processor","doc":"Documentation for `GettextTranslator.Processor`.\nHere we process parsing the PO files and extracting the messages.","ref":"GettextTranslator.Processor.html"},{"type":"function","title":"GettextTranslator.Processor.run/2","doc":"","ref":"GettextTranslator.Processor.html#run/2"},{"type":"module","title":"GettextTranslator.Processor.LLM","doc":"LLM processor for the translator behaviour.","ref":"GettextTranslator.Processor.LLM.html"},{"type":"function","title":"GettextTranslator.Processor.LLM.translate/2","doc":"","ref":"GettextTranslator.Processor.LLM.html#translate/2"},{"type":"behaviour","title":"GettextTranslator.Processor.Translator","doc":"Translator behavior.","ref":"GettextTranslator.Processor.Translator.html"},{"type":"type","title":"GettextTranslator.Processor.Translator.endpoint/0","doc":"","ref":"GettextTranslator.Processor.Translator.html#t:endpoint/0"},{"type":"type","title":"GettextTranslator.Processor.Translator.opts/0","doc":"","ref":"GettextTranslator.Processor.Translator.html#t:opts/0"},{"type":"type","title":"GettextTranslator.Processor.Translator.provider/0","doc":"","ref":"GettextTranslator.Processor.Translator.html#t:provider/0"},{"type":"callback","title":"GettextTranslator.Processor.Translator.translate/2","doc":"","ref":"GettextTranslator.Processor.Translator.html#c:translate/2"},{"type":"module","title":"GettextTranslator.Util.GitHub","doc":"","ref":"GettextTranslator.Util.GitHub.html"},{"type":"function","title":"GettextTranslator.Util.GitHub.create_github_programmatic_pr/4","doc":"","ref":"GettextTranslator.Util.GitHub.html#create_github_programmatic_pr/4"},{"type":"module","title":"GettextTranslator.Util.GitLab","doc":"","ref":"GettextTranslator.Util.GitLab.html"},{"type":"function","title":"GettextTranslator.Util.GitLab.create_gitlab_programmatic_mr/4","doc":"","ref":"GettextTranslator.Util.GitLab.html#create_gitlab_programmatic_mr/4"},{"type":"module","title":"GettextTranslator.Util.Helper","doc":"Helper functions","ref":"GettextTranslator.Util.Helper.html"},{"type":"function","title":"GettextTranslator.Util.Helper.empty_string?/1","doc":"","ref":"GettextTranslator.Util.Helper.html#empty_string?/1"},{"type":"function","title":"GettextTranslator.Util.Helper.ensure_config_table/0","doc":"","ref":"GettextTranslator.Util.Helper.html#ensure_config_table/0"},{"type":"function","title":"GettextTranslator.Util.Helper.extract_domain_from_path/1","doc":"","ref":"GettextTranslator.Util.Helper.html#extract_domain_from_path/1"},{"type":"function","title":"GettextTranslator.Util.Helper.get_application/0","doc":"","ref":"GettextTranslator.Util.Helper.html#get_application/0"},{"type":"function","title":"GettextTranslator.Util.Helper.get_config/1","doc":"","ref":"GettextTranslator.Util.Helper.html#get_config/1"},{"type":"function","title":"GettextTranslator.Util.Helper.lc_messages/0","doc":"","ref":"GettextTranslator.Util.Helper.html#lc_messages/0"},{"type":"function","title":"GettextTranslator.Util.Helper.store_config/2","doc":"","ref":"GettextTranslator.Util.Helper.html#store_config/2"},{"type":"module","title":"GettextTranslator.Util.MakePullRequest","doc":"","ref":"GettextTranslator.Util.MakePullRequest.html"},{"type":"function","title":"GettextTranslator.Util.MakePullRequest.create_pull_request/2","doc":"","ref":"GettextTranslator.Util.MakePullRequest.html#create_pull_request/2"},{"type":"module","title":"GettextTranslator.Util.Parser","doc":"Parse files in the gettext root folder","ref":"GettextTranslator.Util.Parser.html"},{"type":"function","title":"GettextTranslator.Util.Parser.parse_provider/0","doc":"","ref":"GettextTranslator.Util.Parser.html#parse_provider/0"},{"type":"function","title":"GettextTranslator.Util.Parser.scan/1","doc":"","ref":"GettextTranslator.Util.Parser.html#scan/1"},{"type":"module","title":"GettextTranslator.Util.PathHelper","doc":"Helper functions for working with PO and changelog file paths.","ref":"GettextTranslator.Util.PathHelper.html"},{"type":"function","title":"GettextTranslator.Util.PathHelper.changelog_path_for_po/2","doc":"Gets the changelog path corresponding to a PO file.","ref":"GettextTranslator.Util.PathHelper.html#changelog_path_for_po/2"},{"type":"function","title":"Examples - GettextTranslator.Util.PathHelper.changelog_path_for_po/2","doc":"iex> changelog_path_for_po(\"priv/gettext/uk/LC_MESSAGES/default.po\", :my_app)\n    \"/path/to/my_app/priv/translation_changelog/uk_default_changelog.json\"","ref":"GettextTranslator.Util.PathHelper.html#changelog_path_for_po/2-examples"},{"type":"function","title":"GettextTranslator.Util.PathHelper.ensure_changelog_dir/1","doc":"Ensures the translation_changelog directory exists.","ref":"GettextTranslator.Util.PathHelper.html#ensure_changelog_dir/1"},{"type":"function","title":"Examples - GettextTranslator.Util.PathHelper.ensure_changelog_dir/1","doc":"iex> ensure_changelog_dir(:my_app)\n    :ok","ref":"GettextTranslator.Util.PathHelper.html#ensure_changelog_dir/1-examples"},{"type":"function","title":"GettextTranslator.Util.PathHelper.extract_domain/1","doc":"Extracts the domain from a PO file path.","ref":"GettextTranslator.Util.PathHelper.html#extract_domain/1"},{"type":"function","title":"Examples - GettextTranslator.Util.PathHelper.extract_domain/1","doc":"iex> extract_domain(\"priv/gettext/uk/LC_MESSAGES/default.po\")\n    \"default\"","ref":"GettextTranslator.Util.PathHelper.html#extract_domain/1-examples"},{"type":"function","title":"GettextTranslator.Util.PathHelper.extract_language_code/1","doc":"Extracts the language code from a PO file path.","ref":"GettextTranslator.Util.PathHelper.html#extract_language_code/1"},{"type":"function","title":"Examples - GettextTranslator.Util.PathHelper.extract_language_code/1","doc":"iex> extract_language_code(\"priv/gettext/uk/LC_MESSAGES/default.po\")\n    \"uk\"","ref":"GettextTranslator.Util.PathHelper.html#extract_language_code/1-examples"},{"type":"function","title":"GettextTranslator.Util.PathHelper.gettext_dir/1","doc":"Returns the appropriate gettext directory path.","ref":"GettextTranslator.Util.PathHelper.html#gettext_dir/1"},{"type":"function","title":"Examples - GettextTranslator.Util.PathHelper.gettext_dir/1","doc":"iex> gettext_dir(:my_app)\n    \"/path/to/my_app/priv/gettext\"","ref":"GettextTranslator.Util.PathHelper.html#gettext_dir/1-examples"},{"type":"function","title":"GettextTranslator.Util.PathHelper.po_path_for_changelog/2","doc":"Gets the source PO file path from a changelog path.","ref":"GettextTranslator.Util.PathHelper.html#po_path_for_changelog/2"},{"type":"function","title":"Examples - GettextTranslator.Util.PathHelper.po_path_for_changelog/2","doc":"iex> po_path_for_changelog(\"priv/translation_changelog/uk_default_changelog.json\", :my_app)\n    \"/path/to/my_app/priv/gettext/uk/LC_MESSAGES/default.po\"","ref":"GettextTranslator.Util.PathHelper.html#po_path_for_changelog/2-examples"},{"type":"function","title":"GettextTranslator.Util.PathHelper.translation_changelog_dir/1","doc":"Returns the appropriate translation changelog directory path.","ref":"GettextTranslator.Util.PathHelper.html#translation_changelog_dir/1"},{"type":"function","title":"Examples - GettextTranslator.Util.PathHelper.translation_changelog_dir/1","doc":"iex> translation_changelog_dir(:my_app)\n    \"/path/to/my_app/priv/translation_changelog\"","ref":"GettextTranslator.Util.PathHelper.html#translation_changelog_dir/1-examples"},{"type":"module","title":"GettextTranslator.Util.PoHelper","doc":"","ref":"GettextTranslator.Util.PoHelper.html"},{"type":"function","title":"GettextTranslator.Util.PoHelper.get_message_id/1","doc":"","ref":"GettextTranslator.Util.PoHelper.html#get_message_id/1"},{"type":"function","title":"GettextTranslator.Util.PoHelper.update_po_message/2","doc":"","ref":"GettextTranslator.Util.PoHelper.html#update_po_message/2"},{"type":"module","title":"GettextTranslator.Dashboard","doc":"Phoenix LiveDashboard integration for GettextTranslator.\n\nThis module provides functions to register the GettextTranslator dashboard\nwith your Phoenix application.","ref":"GettextTranslator.Dashboard.html"},{"type":"module","title":"Setup - GettextTranslator.Dashboard","doc":"1. Add the required dependencies to your mix.exs:\n\n```elixir\ndef deps do\n  [\n    {:gettext_translator, \"~> 0.4.0\"},\n    {:phoenix_live_dashboard, \">= 0.6.0\"},\n    {:phoenix_live_view, \">= 0.17.0\"}\n  ]\nend\n```\n\n2. Add the GettextTranslator supervisor to your application:\n\n```elixir\n# lib/my_app/application.ex\ndef start(_type, _args) do\n  children = [\n    # ... other children\n    GettextTranslator.Supervisor\n  ]\n\n  opts = [strategy: :one_for_one, name: MyApp.Supervisor]\n  Supervisor.start_link(children, opts)\nend\n```\n\n3. Add the dashboard page to your Phoenix router:\n\n```elixir\n# lib/my_app_web/router.ex\nimport Phoenix.LiveDashboard.Router\n\nscope \"/\" do\n  pipe_through [:browser, :admin_auth] # replace with your actual pipeline\n\n  live_dashboard \"/dashboard\",\n    metrics: MyAppWeb.Telemetry,\n    additional_pages: GettextTranslator.Dashboard.page_config(gettext_path: \"priv/gettext\")\nend\n```","ref":"GettextTranslator.Dashboard.html#module-setup"},{"type":"module","title":"Usage - GettextTranslator.Dashboard","doc":"Once set up, you can access the Gettext Translations page from your Phoenix LiveDashboard.\nThe dashboard allows you to:\n\n- View all translations across all language files\n- Filter translations by language, domain, and status\n- Edit translations directly in the UI\n- Commit changes back to PO files\n- Create Git commits and PRs (if the git_cli dependency is available)\n\nYou can also continue to use the mix task for batch translation:\n\n```\nmix gettext_translator.run\n```","ref":"GettextTranslator.Dashboard.html#module-usage"},{"type":"function","title":"GettextTranslator.Dashboard.ensure_dashboard_dependencies_loaded?/0","doc":"Checks if the Phoenix.LiveDashboard and Phoenix.LiveView dependencies are available.","ref":"GettextTranslator.Dashboard.html#ensure_dashboard_dependencies_loaded?/0"},{"type":"function","title":"GettextTranslator.Dashboard.load_translations/1","doc":"Loads translations from the given gettext path.\n\nThis must be called after the translation store is started to load the\ntranslations into memory.\n\nFor release environments, use an absolute path:\n`Application.app_dir(:my_app, \"priv/gettext\")`\n\nReturns `{:ok, count}` where count is the number of translations loaded,\nor `{:error, reason}` if loading failed.","ref":"GettextTranslator.Dashboard.html#load_translations/1"},{"type":"function","title":"GettextTranslator.Dashboard.page/1","doc":"Returns the gettext dashboard page configuration.","ref":"GettextTranslator.Dashboard.html#page/1"},{"type":"function","title":"Options - GettextTranslator.Dashboard.page/1","doc":"* `:gettext_path` - Path to the gettext directory (default: \"priv/gettext\")\n* `:application` - The OTP application name used for resolving absolute paths in releases","ref":"GettextTranslator.Dashboard.html#page/1-options"},{"type":"function","title":"Example - GettextTranslator.Dashboard.page/1","doc":"```elixir\n# When manually constructing the dashboard pages\nadditional_pages = [\nmy_custom_page: {MyCustomPage, []},\ngettext_translations: GettextTranslator.Dashboard.page(\n  gettext_path: \"priv/gettext\",\n  application: :my_app\n)\n]\n```","ref":"GettextTranslator.Dashboard.html#page/1-example"},{"type":"function","title":"GettextTranslator.Dashboard.page_config/1","doc":"Returns a list of additional pages configuration for Phoenix LiveDashboard.","ref":"GettextTranslator.Dashboard.html#page_config/1"},{"type":"function","title":"Options - GettextTranslator.Dashboard.page_config/1","doc":"* `:gettext_path` - Path to the gettext directory (default: \"priv/gettext\")\n* `:application` - The OTP application name used for resolving absolute paths in releases","ref":"GettextTranslator.Dashboard.html#page_config/1-options"},{"type":"function","title":"Example - GettextTranslator.Dashboard.page_config/1","doc":"```elixir\nlive_dashboard \"/dashboard\",\nmetrics: MyAppWeb.Telemetry,\nadditional_pages: GettextTranslator.Dashboard.page_config(\n  gettext_path: \"priv/gettext\",\n  application: :my_app\n)\n```","ref":"GettextTranslator.Dashboard.html#page_config/1-example"},{"type":"function","title":"GettextTranslator.Dashboard.quick_test/1","doc":"Helper function to quickly test the dashboard API in IEx.\n\nThis function starts the translation store, loads translations from the\ngiven gettext path, and returns basic stats about the loaded translations.","ref":"GettextTranslator.Dashboard.html#quick_test/1"},{"type":"function","title":"Example - GettextTranslator.Dashboard.quick_test/1","doc":"```elixir\niex> GettextTranslator.Dashboard.quick_test(\"priv/gettext\")\n```","ref":"GettextTranslator.Dashboard.html#quick_test/1-example"},{"type":"function","title":"GettextTranslator.Dashboard.start_translation_store/0","doc":"Starts the translation store process manually if needed.\n\nThis is usually handled by the GettextTranslator.Supervisor, but can be\ncalled directly if needed.","ref":"GettextTranslator.Dashboard.html#start_translation_store/0"},{"type":"module","title":"GettextTranslator.Dashboard.DashboardPage","doc":"Phoenix LiveDashboard page for managing Gettext translations.\n\nThis module integrates with Phoenix LiveDashboard to provide a UI for viewing\nand managing gettext translations.","ref":"GettextTranslator.Dashboard.DashboardPage.html"},{"type":"module","title":"GettextTranslator.Supervisor","doc":"Supervisor for GettextTranslator processes.\n\nThis module provides a supervisor that can be included in your application's\nsupervision tree to manage the GettextTranslator dashboard components.","ref":"GettextTranslator.Supervisor.html"},{"type":"module","title":"Usage - GettextTranslator.Supervisor","doc":"Add to your application supervision tree:\n\n```elixir\n# In your application.ex\ndef start(_type, _args) do\n  children = [\n    # ... other children\n    GettextTranslator.Supervisor\n  ]\n\n  opts = [strategy: :one_for_one, name: MyApp.Supervisor]\n  Supervisor.start_link(children, opts)\nend\n```","ref":"GettextTranslator.Supervisor.html#module-usage"},{"type":"function","title":"GettextTranslator.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"GettextTranslator.Supervisor.html#child_spec/1"},{"type":"module","title":"GettextTranslator.Store","doc":"In-memory store for translation entries and changelog using ETS.\nThis module is responsible for the low-level persistence layer.","ref":"GettextTranslator.Store.html"},{"type":"function","title":"GettextTranslator.Store.child_spec/1","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","ref":"GettextTranslator.Store.html#child_spec/1"},{"type":"function","title":"GettextTranslator.Store.count_approved_translations/0","doc":"Get the current count for approved translations","ref":"GettextTranslator.Store.html#count_approved_translations/0"},{"type":"function","title":"GettextTranslator.Store.count_by_status/1","doc":"","ref":"GettextTranslator.Store.html#count_by_status/1"},{"type":"function","title":"GettextTranslator.Store.count_modified_translations/0","doc":"Counts the number of translations with :modified status.","ref":"GettextTranslator.Store.html#count_modified_translations/0"},{"type":"function","title":"GettextTranslator.Store.get_changelog/1","doc":"","ref":"GettextTranslator.Store.html#get_changelog/1"},{"type":"function","title":"GettextTranslator.Store.get_entries_by_file/0","doc":"","ref":"GettextTranslator.Store.html#get_entries_by_file/0"},{"type":"function","title":"GettextTranslator.Store.get_translation/1","doc":"","ref":"GettextTranslator.Store.html#get_translation/1"},{"type":"function","title":"GettextTranslator.Store.increment_approved/0","doc":"Increment the approved translations counter","ref":"GettextTranslator.Store.html#increment_approved/0"},{"type":"function","title":"GettextTranslator.Store.insert_changelog/2","doc":"","ref":"GettextTranslator.Store.html#insert_changelog/2"},{"type":"function","title":"GettextTranslator.Store.insert_translation/2","doc":"","ref":"GettextTranslator.Store.html#insert_translation/2"},{"type":"function","title":"GettextTranslator.Store.list_changelogs/0","doc":"","ref":"GettextTranslator.Store.html#list_changelogs/0"},{"type":"function","title":"GettextTranslator.Store.list_translations/0","doc":"","ref":"GettextTranslator.Store.html#list_translations/0"},{"type":"function","title":"GettextTranslator.Store.reset_approved_counter/0","doc":"Reset the approved translations counter","ref":"GettextTranslator.Store.html#reset_approved_counter/0"},{"type":"function","title":"GettextTranslator.Store.reset_changelogs/0","doc":"","ref":"GettextTranslator.Store.html#reset_changelogs/0"},{"type":"function","title":"GettextTranslator.Store.reset_translations/0","doc":"","ref":"GettextTranslator.Store.html#reset_translations/0"},{"type":"function","title":"GettextTranslator.Store.start_approved_counter/0","doc":"Start the ETS table for approved translations when your application starts.\nCall this in your application's supervision tree.","ref":"GettextTranslator.Store.html#start_approved_counter/0"},{"type":"function","title":"GettextTranslator.Store.start_link/1","doc":"Starts the ETS store.","ref":"GettextTranslator.Store.html#start_link/1"},{"type":"module","title":"GettextTranslator.Store.Changelog","doc":"Service for managing changelog operations.\nMaintains status history of translations with a simple 1:1 mapping.","ref":"GettextTranslator.Store.Changelog.html"},{"type":"function","title":"GettextTranslator.Store.Changelog.approve_translation/1","doc":"Approves a translation in the changelog.","ref":"GettextTranslator.Store.Changelog.html#approve_translation/1"},{"type":"function","title":"GettextTranslator.Store.Changelog.create_new_changelog_entry/2","doc":"Creates a new changelog entry for a new translation or when one doesn't exist.","ref":"GettextTranslator.Store.Changelog.html#create_new_changelog_entry/2"},{"type":"function","title":"GettextTranslator.Store.Changelog.load_changelog_files/2","doc":"Loads changelog files for translations.\nMaps each translation to its corresponding status record.","ref":"GettextTranslator.Store.Changelog.html#load_changelog_files/2"},{"type":"function","title":"GettextTranslator.Store.Changelog.match_changelog_with_translations/0","doc":"Match changelog entries with translations using message_id as the key.","ref":"GettextTranslator.Store.Changelog.html#match_changelog_with_translations/0"},{"type":"function","title":"GettextTranslator.Store.Changelog.save_to_files/0","doc":"Saves all modified changelog entries to disk, while preserving existing entries.\nConverts MODIFIED status to APPROVED during persistence.","ref":"GettextTranslator.Store.Changelog.html#save_to_files/0"},{"type":"function","title":"GettextTranslator.Store.Changelog.update_for_modified_translation/2","doc":"Updates a changelog entry when a translation is modified from the UI.","ref":"GettextTranslator.Store.Changelog.html#update_for_modified_translation/2"},{"type":"module","title":"GettextTranslator.Store.Translation","doc":"Service for managing translation operations.\nHandles processing PO files and translation operations.","ref":"GettextTranslator.Store.Translation.html"},{"type":"function","title":"GettextTranslator.Store.Translation.filter_translations/1","doc":"Filters translations by the given criteria.","ref":"GettextTranslator.Store.Translation.html#filter_translations/1"},{"type":"function","title":"GettextTranslator.Store.Translation.load_translations/1","doc":"Loads all translations from the gettext directories.","ref":"GettextTranslator.Store.Translation.html#load_translations/1"},{"type":"function","title":"GettextTranslator.Store.Translation.save_all_changes/0","doc":"Saves all pending translation changes and changelog entries.\nCalled when saving work or making a PR.","ref":"GettextTranslator.Store.Translation.html#save_all_changes/0"},{"type":"function","title":"GettextTranslator.Store.Translation.save_translations_to_file/2","doc":"","ref":"GettextTranslator.Store.Translation.html#save_translations_to_file/2"},{"type":"function","title":"GettextTranslator.Store.Translation.update_translation/2","doc":"Updates a translation with new values.","ref":"GettextTranslator.Store.Translation.html#update_translation/2"},{"type":"task","title":"mix gettext_translator.run","doc":"GettextTranslator usage:\n * Base using default gettext folder (priv/gettext)\n    ```\n    mix gettext_translator.run\n    ```\n\n * Providing specific gettext folder\n    ```\n    mix gettext_translator.run my_path/gettext\n    ```","ref":"Mix.Tasks.GettextTranslator.Run.html"},{"type":"extras","title":"GettextTranslator","doc":"# GettextTranslator\n\n[![CI](https://github.com/marmend-company/gettext_translator/actions/workflows/main.yml/badge.svg)](https://github.com/marmend-company/gettext_translator/actions/workflows/main.yml)\n\n**GettextTranslator** is a robust translation utility for Elixir projects that leverages advanced AI endpoints to provide high-quality translations. The library seamlessly integrates with Elixir's Gettext, enabling you to maintain the integrity of your application's messages while translating them accurately. It supports multiple AI providers, making it adaptable to your preferred translation service.\n\n**Changelog:** See [CHANGELOG.md](CHANGELOG.md) for detailed changes in each version.","ref":"readme.html"},{"type":"extras","title":"Important Note - GettextTranslator","doc":"Observed that regular `:gettext` will create a different structure for the translations than the `GettextTranslator` does. This create a little chaos in the translations while commiting them to the repo. \nHack to fix it, run you `mix gettext.extract` one more time after translations are done, that will fix the structure and only new translations will be in diff for commit.","ref":"readme.html#important-note"},{"type":"extras","title":"Features - GettextTranslator","doc":"- **Multi-Provider Support:** Easily switch between translation endpoints such as Ollama AI and OpenAI.\n- **Customizable Configurations:** Define your own translation persona, style, and languages to ignore.\n- **CLI Integration:** Translate Gettext files directly from the command line.\n- **Seamless Gettext Integration:** Automatically translate files in your Gettext directory.\n- **Live Dashboard:** \n- Monitor and manage translations through Phoenix LiveDashboard.\n- Detailed view of all translations with filtering and pagination\n- Direct editing of translations in the LiveView\n- Approval workflow for LLM based translations\n- Saving changes back to PO files\n- **Production Ready:** Works in both development and release environments with proper path handling.\n- **Pluralization Support:** Properly handles language-specific plural forms (including Ukrainian with three forms).\n\n#### Upcoming Dashboard Features\nIn upcoming releases, the full dashboard UI will include:\n- Git integration for creating commits and PRs","ref":"readme.html#features"},{"type":"extras","title":"Example - GettextTranslator","doc":"#### List all translations in the dashboard:\n\n![all translations](examples/image.png)\n\n#### View translations in the dashboard:\n\n![view translation](examples/image-1.png)","ref":"readme.html#example"},{"type":"extras","title":"Installation - GettextTranslator","doc":"Add `gettext_translator` to your dependencies in your `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:gettext_translator, \"~> 0.4.0\"}\n  ]\nend\n```\n\nThen, run:\n\n```sh\nmix deps.get\n```","ref":"readme.html#installation"},{"type":"extras","title":"Configuration - GettextTranslator","doc":"Configure GettextTranslator in your `config/config.exs` file. Below are examples using two different AI translation endpoints.","ref":"readme.html#configuration"},{"type":"extras","title":"Using Ollama AI - GettextTranslator","doc":"```elixir\nconfig :gettext_translator, GettextTranslator,\n  endpoint: LangChain.ChatModels.ChatOllamaAI,\n  endpoint_model: \"llama3.2:latest\",\n  endpoint_temperature: 0,\n  endpoint_config: %{}, # Leave empty if running Ollama locally with the default API endpoint\n  persona: \"You are a professional translator. Your goal is to translate the message to the target language while preserving meaning and length.\",\n  style: \"Casual, using simple language\",\n  ignored_languages: [\"en\"]\n```","ref":"readme.html#using-ollama-ai"},{"type":"extras","title":"Using OpenAI - GettextTranslator","doc":"```elixir\nconfig :gettext_translator, GettextTranslator,\n  endpoint: LangChain.ChatModels.ChatOpenAI,\n  endpoint_model: \"gpt-4\",\n  endpoint_temperature: 0,\n  endpoint_config: %{\n    \"openai_key\" => \"YOUR_OPENAI_KEY\",\n    \"openai_org_id\" => \"YOUR_ORG_ID\"\n  },\n  persona: \"You are a professional translator. Your goal is to translate the message to the target language while preserving meaning and length.\",\n  style: \"Casual, using simple language\",\n  ignored_languages: [\"en\"]\n```","ref":"readme.html#using-openai"},{"type":"extras","title":"Usage - GettextTranslator","doc":"","ref":"readme.html#usage"},{"type":"extras","title":"Running the Translator via CLI - GettextTranslator","doc":"#### Translate Using the Default Gettext Folder\nTo translate the default Gettext folder (`priv/gettext`), simply run:\n\n```sh\nmix gettext_translator.run\n```\n\n#### Translate Using a Specific Gettext Folder\nIf your Gettext files are located in a different directory, specify the path:\n\n```sh\nmix gettext_translator.run path/to/your/gettext\n```","ref":"readme.html#running-the-translator-via-cli"},{"type":"extras","title":"Phoenix LiveDashboard Integration (Preview) - GettextTranslator","doc":"GettextTranslator provides a web UI for managing translations through Phoenix LiveDashboard.\n\n> **Note:** The full dashboard UI is under active development. The current version provides a basic view and API access to translations.\n\n#### Setup Dashboard Integration\n\n1. Add the required dependencies to your Phoenix application:\n\n```elixir\ndef deps do\n  [\n    {:gettext_translator, \"~> 0.4.0\"},\n    {:phoenix_live_dashboard, \">= 0.6.0\"},\n    {:phoenix_live_view, \">= 0.17.0\"}\n  ]\nend\n```\n\n2. Add the GettextTranslator supervisor to your application:\n\n```elixir\n# lib/my_app/application.ex\ndef start(_type, _args) do\n  children = [\n    # ... other children\n    GettextTranslator.Supervisor\n  ]\n  \n  opts = [strategy: :one_for_one, name: MyApp.Supervisor]\n  Supervisor.start_link(children, opts)\nend\n```\n\n3. Add the dashboard page to your Phoenix router:\n\n```elixir\n# lib/my_app_web/router.ex\nimport Phoenix.LiveDashboard.Router\n\nscope \"/\" do\n  pipe_through [:browser, :admin_auth] # replace with your actual pipeline\n  \n  live_dashboard \"/dashboard\",\n    metrics: MyAppWeb.Telemetry,\n    additional_pages: \n    [existing pages]\n    ++\n    [\n    gettext_translations: {\n      GettextTranslator.Dashboard.DashboardPage,\n      [\n        # Use relative path, will be resolved at runtime\n        gettext_path: \"priv/gettext\",\n        application: :my_app\n      ]\n    }\n  ]\nend\n```\n\n4. For Mix Releases we need to add the gettext_translator output files to the release assets:\n\n```elixir\ndef project do\n    [\n      app: :my_app,\n      ...,\n      deps: deps(),\n      releases: [\n        my_app: [\n          ...,\n          # Explicitly include translation_changelog directory\n          steps: [:assemble, &copy_translation_files/1]\n        ]\n      ]\n    ]\n  end\n\n  defp copy_translation_files(release) do\n    File.mkdir_p!(Path.join([release.path, \"lib\", \"my_app-#{release.version}\", \"priv\", \"translation_changelog\"]))\n\n    source_dir = \"priv/translation_changelog\"\n    target_dir = Path.join([release.path, \"lib\", \"my_app-#{release.version}\", \"priv\", \"translation_changelog\"])\n\n    if File.exists?(source_dir) do\n      File.cp_r!(source_dir, target_dir)\n    end\n\n    release\n  end\n```\n\n#### Using the Translation API\n\nWhile the full UI is under development, you can use the Translation API directly in your application:\n\n```elixir\n# Start the store manually if not using GettextTranslator.Supervisor\nGettextTranslator.Dashboard.start_translation_store()\n\n# Load translations from your gettext path\nGettextTranslator.Dashboard.load_translations(\"priv/gettext\")\n\n# Get all loaded translations\ntranslations = GettextTranslator.Dashboard.TranslationStore.list_translations()\n\n# Filter translations by criteria\npending = GettextTranslator.Dashboard.TranslationStore.filter_translations(%{status: :pending})\nes_translations = GettextTranslator.Dashboard.TranslationStore.filter_translations(%{language_code: \"es\"})\n```","ref":"readme.html#phoenix-livedashboard-integration-preview"},{"type":"extras","title":"Git Integration - GettextTranslator","doc":"Get a token from your Git provider, write_repository and api access is sufficient. As the logic is making PR/MR requests.\n#### GitHub\n\nTo use GitHub as a git provider, you need to configure the following options in your `config/config.exs`:\n\n```elixir\nconfig :gettext_translator, :git_config, %{\n    github_token: \"YOUR_GITHUB_TOKEN\",\n    repo_url: \"https://github.com/YOUR_USERNAME/YOUR_REPOSITORY\",\n    base_branch: \"main\",\n    provider: \"github\"\n  }\n```\n\n#### GitLab\n\nTo use GitLab as a git provider, you need to configure the following options in your `config/config.exs`:\n\n```elixir\nconfig :gettext_translator, :git_config, %{\n    gitlab_token: \"YOUR_GITLAB_TOKEN\",\n    repo_url: \"https://gitlab.com/YOUR_USERNAME/YOUR_REPOSITORY\",\n    base_branch: \"main\",\n    provider: \"gitlab\"\n  }\n```","ref":"readme.html#git-integration"},{"type":"extras","title":"Advanced Examples - GettextTranslator","doc":"#### Batch Translation Script\nFor projects with multiple Gettext directories, you can create a custom Elixir module to run translations in batch:\n\n```elixir\ndefmodule BatchTranslator do\n  def run do\n    [\"priv/gettext\", \"lib/my_app/gettext\"]\n    |> Enum.each(fn path ->\n      System.cmd(\"mix\", [\"gettext_translator.run\", path])\n    end)\n  end\nend\n```\n\nRun the batch translation in IEx:\n\n```sh\niex -S mix\niex> BatchTranslator.run()\n```\n\n#### Overriding Configurations at Runtime\nYou might want to adjust the translation behavior without changing your config files permanently. Override settings in IEx:\n\n```elixir\niex> Application.put_env(:gettext_translator, :persona, \"Translate concisely and accurately.\")\n```","ref":"readme.html#advanced-examples"},{"type":"extras","title":"Documentation - GettextTranslator","doc":"Comprehensive documentation is available on [HexDocs](https://hexdocs.pm/gettext_translator). It covers detailed configuration options, advanced usage, integration guides, and best practices.","ref":"readme.html#documentation"},{"type":"extras","title":"Contributing - GettextTranslator","doc":"We welcome contributions from the community! Please review our [CONTRIBUTING.md](CONTRIBUTING.md) for guidelines on submitting issues and pull requests.","ref":"readme.html#contributing"},{"type":"extras","title":"License - GettextTranslator","doc":"GettextTranslator is released under the Apache License 2.0 License.","ref":"readme.html#license"},{"type":"extras","title":"Changelog","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\n## [0.4.0] - 2025-05-08\n    [Breaking chanegs]\n- Reworked changelog integration to use a simple 1:1 mapping between translations and changelog entries. Previous changelog will be overwritten, therefore new changelog entries will be created with a different structure.\n- Fixed bugs, refactored code.\n- Added visibility which changes are done in current session and will be commited or saved to files.\n\n## [0.3.0] - 2025-05-04\n- Git integration for committing changes as PRs.\n- Support Gitlab and Github (not fully tested).\n\n## [0.2.3] - 2025-05-01\n- Fixes for release environments\n\n## [0.2.2] - 2025-05-01\n- Update regex pattern in `extract_language_code/1` to correctly match LC_MESSAGES folder structure\n- Extract common path patterns to module attributes to reduce repetition\n- Add private `app_path/2` helper to standardize path generation\n- Ensure consistent path handling across all helper functions\n\n## [0.2.1] - 2025-05-01","ref":"changelog.html"},{"type":"extras","title":"Fixed - Changelog","doc":"- Fixed path resolution in release environments by using Application.app_dir\n- Added application parameter to properly resolve paths in releases\n- Fixed Ukrainian pluralization by adding support for required third plural form\n- Modified TranslationStore to correctly save and load translations in releases\n- Added ETS-based configuration for LiveDashboard integration\n- Improved PathHelper to handle both development and production environments","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- New helpers for proper path resolution in both dev and release environments\n- ETS-based configuration state management between LiveView mounts\n- Support for additional plural forms required by specific languages\n\n## [0.2.0] - 2025-03-08","ref":"changelog.html#added"},{"type":"extras","title":"Added - Changelog","doc":"- Phoenix LiveDashboard integration for monitoring and managing translations\n- In-memory translation store using ETS tables\n- Web UI for viewing, editing, and approving translations\n- Filtering and pagination in dashboard\n- Improved documentation with dashboard setup guide","ref":"changelog.html#added"},{"type":"extras","title":"Fixed - Changelog","doc":"- LLM integration for gettext files.\n\n## [0.1.0] - 2025-02-23","ref":"changelog.html#fixed"},{"type":"extras","title":"Added - Changelog","doc":"- Initial release of GettextTranslator.\n- Multi-provider support for AI translation.\n- CLI integration for translating Gettext files.\n- Basic documentation and configuration examples.","ref":"changelog.html#added"},{"type":"extras","title":"Contributing to GettextTranslator","doc":"# Contributing to GettextTranslator\n\nThank you for considering contributing to Gettext Translator! We welcome improvements, bug reports, and feature suggestions from the community.","ref":"contributing.html"},{"type":"extras","title":"How to Contribute - Contributing to GettextTranslator","doc":"","ref":"contributing.html#how-to-contribute"},{"type":"extras","title":"Reporting Bugs - Contributing to GettextTranslator","doc":"- Please use the [Issues](https://github.com/marmend-company/gettext_translator/issues) section to report any bugs.\n- Include detailed information such as steps to reproduce, expected vs. actual behavior, and screenshots if applicable.","ref":"contributing.html#reporting-bugs"},{"type":"extras","title":"Suggesting Enhancements - Contributing to GettextTranslator","doc":"- Use the [Issues](https://github.com/marmend-company/gettext_translator/issues) section to propose new features or improvements.\n- Discuss your ideas with the community to gather feedback before implementation.","ref":"contributing.html#suggesting-enhancements"},{"type":"extras","title":"Pull Request Process - Contributing to GettextTranslator","doc":"1. **Fork** the repository.\n2. **Create a new branch** with a descriptive name for your changes.\n3. **Implement your changes** and ensure that you add tests if applicable.\n4. **Run the test suite** to confirm all tests pass.\n5. **Submit a pull request** to the `main` branch with a clear description of your changes.","ref":"contributing.html#pull-request-process"},{"type":"extras","title":"Code of Conduct - Contributing to GettextTranslator","doc":"By contributing, you agree to abide by our [Code of Conduct](CODE_OF_CONDUCT.md). Please review it before making any contributions.","ref":"contributing.html#code-of-conduct"},{"type":"extras","title":"Questions? - Contributing to GettextTranslator","doc":"If you have any questions or need further assistance, please feel free to open an issue or join the discussion on [GitHub Discussions](https://github.com/marmend-company/gettext_translator/discussions).\n\nHappy coding!","ref":"contributing.html#questions"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.37.2"}}